OGRE: Ogre::v1::MeshManager Class Reference

| OGRE 2.2.4 Object-Oriented Graphics Rendering Engine

Classes | Public Types | Public Member Functions | Static Public Member Functions | Public Attributes | List of all members
Ogre::v1::MeshManager Class Reference
Core » Resources

Handles the management of mesh resources. More...

`#include <OgreMeshManager.h>`

Inheritance diagram for Ogre::v1::MeshManager:
[legend]

## Public Types
typedef std::pair< ResourcePtr, bool > | ResourceCreateOrRetrieveResult
typedef map< ResourceHandle, ResourcePtr >::type | ResourceHandleMap
typedef unordered_map< String, ResourcePtr >::type | ResourceMap
typedef MapIterator< ResourceHandleMap > | ResourceMapIterator
typedef unordered_map< String, ResourceMap >::type | ResourceWithGroupMap

## Public Member Functions
| MeshManager ()
| ~MeshManager ()
void | _initialise (void)
| Initialises the manager, only to be called by OGRE internally. More...
virtual void | _notifyResourceLoaded (Resource *res)
| Notify this manager that a resource which it manages has been loaded. More...
virtual void | _notifyResourceTouched (Resource *res)
| Notify this manager that a resource which it manages has been 'touched', i.e. More...
virtual void | _notifyResourceUnloaded (Resource *res)
| Notify this manager that a resource which it manages has been unloaded. More...
MeshPtr | create (const String &name, const String &group, bool isManual=false, ManualResourceLoader *loader=0, const NameValuePairList *createParams=0)
| Create a new mesh. More...
PatchMeshPtr | createBezierPatch (const String &name, const String &groupName, void *controlPointBuffer, VertexDeclaration *declaration, size_t width, size_t height, size_t uMaxSubdivisionLevel=PatchSurface::AUTO_LEVEL, size_t vMaxSubdivisionLevel=PatchSurface::AUTO_LEVEL, PatchSurface::VisibleSide visibleSide=PatchSurface::VS_FRONT, HardwareBuffer::Usage vbUsage=HardwareBuffer::HBU_STATIC_WRITE_ONLY, HardwareBuffer::Usage ibUsage=HardwareBuffer::HBU_DYNAMIC_WRITE_ONLY, bool vbUseShadow=true, bool ibUseShadow=true)
| Creates a Bezier patch based on an array of control vertices. More...
MeshPtr | createCurvedIllusionPlane (const String &name, const String &groupName, const Plane &plane, Real width, Real height, Real curvature, int xsegments=1, int ysegments=1, bool normals=true, unsigned short numTexCoordSets=1, Real uTile=1.0f, Real vTile=1.0f, const Vector3 &upVector=Vector3::UNIT_Y, const Quaternion &orientation=Quaternion::IDENTITY, HardwareBuffer::Usage vertexBufferUsage=HardwareBuffer::HBU_STATIC_WRITE_ONLY, HardwareBuffer::Usage indexBufferUsage=HardwareBuffer::HBU_STATIC_WRITE_ONLY, bool vertexShadowBuffer=true, bool indexShadowBuffer=true, int ySegmentsToKeep=-1)
| Creates a plane, which because of it's texture coordinates looks like a curved surface, useful for skies in a skybox. More...
MeshPtr | createCurvedPlane (const String &name, const String &groupName, const Plane &plane, Real width, Real height, Real bow=0.5f, int xsegments=1, int ysegments=1, bool normals=false, unsigned short numTexCoordSets=1, Real uTile=1.0f, Real vTile=1.0f, const Vector3 &upVector=Vector3::UNIT_Y, HardwareBuffer::Usage vertexBufferUsage=HardwareBuffer::HBU_STATIC_WRITE_ONLY, HardwareBuffer::Usage indexBufferUsage=HardwareBuffer::HBU_STATIC_WRITE_ONLY, bool vertexShadowBuffer=true, bool indexShadowBuffer=true)
| Creates a genuinely curved plane, by default majoring on the x/y axes facing positive Z. More...
MeshPtr | createManual (const String &name, const String &groupName, ManualResourceLoader *loader=0)
| Creates a new Mesh specifically for manual definition rather than loading from an object file. More...
virtual ResourceCreateOrRetrieveResult | createOrRetrieve (const String &name, const String &group, bool isManual=false, ManualResourceLoader *loader=0, const NameValuePairList *createParams=0)
| Create a new resource, or retrieve an existing one with the same name if it already exists. More...
ResourceCreateOrRetrieveResult | createOrRetrieve (const String &name, const String &group, bool isManual=false, ManualResourceLoader *loader=0, const NameValuePairList *params=0, HardwareBuffer::Usage vertexBufferUsage=HardwareBuffer::HBU_STATIC_WRITE_ONLY, HardwareBuffer::Usage indexBufferUsage=HardwareBuffer::HBU_STATIC_WRITE_ONLY, bool vertexBufferShadowed=true, bool indexBufferShadowed=true)
| Create a new mesh, or retrieve an existing one with the same name if it already exists. More...
MeshPtr | createPlane (const String &name, const String &groupName, const Plane &plane, Real width, Real height, int xsegments=1, int ysegments=1, bool normals=true, unsigned short numTexCoordSets=1, Real uTile=1.0f, Real vTile=1.0f, const Vector3 &upVector=Vector3::UNIT_Y, HardwareBuffer::Usage vertexBufferUsage=HardwareBuffer::HBU_STATIC_WRITE_ONLY, HardwareBuffer::Usage indexBufferUsage=HardwareBuffer::HBU_STATIC_WRITE_ONLY, bool vertexShadowBuffer=true, bool indexShadowBuffer=true)
| Creates a basic plane, by default majoring on the x/y axes facing positive Z. More...
virtual ResourcePtr | createResource (const String &name, const String &group, bool isManual=false, ManualResourceLoader *loader=0, const NameValuePairList *createParams=0)
| Creates a new blank resource, but does not immediately load it. More...
void | destroyAllResourcePools ()
| destroy all pools More...
void | destroyResourcePool (const String &name)
| Destroy a resource pool. More...
void | destroyResourcePool (ResourcePool *pool)
| Destroy a resource pool. More...
Real | getBoundsPaddingFactor (void)
| Gets the factor by which the bounding box of an entity is padded. More...
virtual ResourcePtr | getByHandle (ResourceHandle handle)
| Retrieves a pointer to a resource by handle, or null if the resource does not exist. More...
MeshPtr | getByName (const String &name, const String &groupName=ResourceGroupManager::AUTODETECT_RESOURCE_GROUP_NAME)
| Get a resource by name. More...
MeshSerializerListener * | getListener ()
| Gets the listener used to control mesh loading through the serializer. More...
virtual Real | getLoadingOrder (void) const
| Gets the relative loading order of resources of this type. More...
virtual size_t | getMemoryBudget (void) const
| Get the limit on the amount of memory this resource handler may use. More...
virtual size_t | getMemoryUsage (void) const
| Gets the current memory usage, in bytes. More...
bool | getPrepareAllMeshesForShadowVolumes (void)
| Retrieves whether all Meshes should prepare themselves for shadow volumes. More...
virtual ResourcePtr | getResourceByName (const String &name, const String &groupName=ResourceGroupManager::AUTODETECT_RESOURCE_GROUP_NAME)
| Retrieves a pointer to a resource by name, or null if the resource does not exist. More...
ResourceMapIterator | getResourceIterator (void)
| Returns an iterator over all resources in this manager. More...
ResourcePool * | getResourcePool (const String &name)
| Create a resource pool, or reuse one that already exists. More...
const String & | getResourceType (void) const
| Gets a string identifying the type of resource this manager handles. More...
virtual const StringVector & | getScriptPatterns (void) const
| Gets the file patterns which should be used to find scripts for this ResourceManager. More...
virtual bool | getVerbose (void)
| Gets whether this manager and its resources habitually produce log output. More...
MeshPtr | load (const String &filename, const String &groupName, HardwareBuffer::Usage vertexBufferUsage=HardwareBuffer::HBU_STATIC_WRITE_ONLY, HardwareBuffer::Usage indexBufferUsage=HardwareBuffer::HBU_STATIC_WRITE_ONLY, bool vertexBufferShadowed=true, bool indexBufferShadowed=true)
| Loads a mesh from a file, making it immediately available for use. More...
virtual ResourcePtr | load (const String &name, const String &group, bool isManual=false, ManualResourceLoader *loader=0, const NameValuePairList *loadParams=0, bool backgroundThread=false)
| Generic load method, used to create a Resource specific to this ResourceManager without using one of the specialised 'load' methods (containing per-Resource-type parameters). More...
void | loadResource (Resource *res)
void | operator delete (void *ptr)
void | operator delete (void *ptr, const char *, int, const char *)
void | operator delete (void *ptr, void *)
void | operator delete[] (void *ptr)
void | operator delete[] (void *ptr, const char *, int, const char *)
void * | operator new (size_t sz)
void * | operator new (size_t sz, const char *file, int line, const char *func)
| operator new, with debug line info More...
void * | operator new (size_t sz, void *ptr)
| placement operator new More...
void * | operator new[] (size_t sz)
void * | operator new[] (size_t sz, const char *file, int line, const char *func)
| array operator new, with debug line info More...
virtual void | parseScript (DataStreamPtr &stream, const String &groupName)
| Parse the definition of a set of resources from a script file. More...
MeshPtr | prepare (const String &filename, const String &groupName, HardwareBuffer::Usage vertexBufferUsage=HardwareBuffer::HBU_STATIC_WRITE_ONLY, HardwareBuffer::Usage indexBufferUsage=HardwareBuffer::HBU_STATIC_WRITE_ONLY, bool vertexBufferShadowed=true, bool indexBufferShadowed=true)
| Prepares a mesh for loading from a file. More...
virtual ResourcePtr | prepare (const String &name, const String &group, bool isManual=false, ManualResourceLoader *loader=0, const NameValuePairList *loadParams=0, bool backgroundThread=false)
| Generic prepare method, used to create a Resource specific to this ResourceManager without using one of the specialised 'prepare' methods (containing per-Resource-type parameters). More...
virtual void | prepareResource (Resource *resource)
| Called when a resource wishes to load. More...
void | reloadAll (bool reloadableOnly=true)
| Caused all currently loaded resources to be reloaded. More...
virtual void | reloadAll (Resource::LoadingFlags flags)
| Caused all currently loaded resources to be reloaded. More...
void | reloadUnreferencedResources (bool reloadableOnly=true)
| Caused all currently loaded but not referenced by any other object resources to be reloaded. More...
virtual void | remove (const ResourcePtr &r)
| Remove a single resource. More...
virtual void | remove (const String &name)
| Remove a single resource by name. More...
virtual void | remove (ResourceHandle handle)
| Remove a single resource by handle. More...
virtual void | removeAll (void)
| Removes all resources. More...
virtual void | removeUnreferencedResources (bool reloadableOnly=true)
| Remove all resources which are not referenced by any other object. More...
virtual bool | resourceExists (const String &name)
| Returns whether the named resource exists in this manager. More...
virtual bool | resourceExists (ResourceHandle handle)
| Returns whether a resource with the given handle exists in this manager. More...
void | setBoundsPaddingFactor (Real paddingFactor)
| Sets the factor by which the bounding box of an entity is padded. More...
void | setListener (MeshSerializerListener *listener)
| Sets the listener used to control mesh loading through the serializer. More...
virtual void | setMemoryBudget (size_t bytes)
| Set a limit on the amount of memory this resource handler may use. More...
void | setPrepareAllMeshesForShadowVolumes (bool enable)
| Tells the mesh manager that all future meshes should prepare themselves for shadow volumes on loading. More...
virtual void | setVerbose (bool v)
| Sets whether this manager and its resources habitually produce log output. More...
virtual void | unload (const String &name)
| Unloads a single resource by name. More...
virtual void | unload (ResourceHandle handle)
| Unloads a single resource by handle. More...
void | unloadAll (bool reloadableOnly=true)
| Unloads all resources. More...
virtual void | unloadAll (Resource::LoadingFlags flags)
| Unloads all resources. More...
void | unloadUnreferencedResources (bool reloadableOnly=true)
| Unload all resources which are not referenced by any other object. More...

## Static Public Member Functions
static MeshManager & | getSingleton (void)
| Override standard Singleton retrieval. More...
static MeshManager * | getSingletonPtr (void)
| Override standard Singleton retrieval. More...
static void | unshareVertices (Mesh *mesh)
| Called when we you use a mesh which has shared vertices, the function creates separate vertex/index buffers and also recreates the bone assignments. More...

## Public Attributes
| OGRE_AUTO_MUTEX

## Detailed Description

Handles the management of mesh resources.

Remarks
  This class deals with the runtime management of mesh data; like other resource managers it handles the creation of resources (in this case mesh data), working within a fixed memory budget.

## Member Typedef Documentation

## ◆ ResourceCreateOrRetrieveResult

typedef std::pair<ResourcePtr, bool> Ogre::ResourceManager::ResourceCreateOrRetrieveResult
| inherited

## ◆ ResourceHandleMap

typedef map<ResourceHandle, ResourcePtr>::type Ogre::ResourceManager::ResourceHandleMap
| inherited

## ◆ ResourceMap

typedef unordered_map< String, ResourcePtr >::type Ogre::ResourceManager::ResourceMap
| inherited

## ◆ ResourceMapIterator

typedef MapIterator<ResourceHandleMap> Ogre::ResourceManager::ResourceMapIterator
| inherited

## ◆ ResourceWithGroupMap

typedef unordered_map< String, ResourceMap >::type Ogre::ResourceManager::ResourceWithGroupMap
| inherited

## Constructor & Destructor Documentation

## ◆ MeshManager()

Ogre::v1::MeshManager::MeshManager | ( |  | ) |

## ◆ ~MeshManager()

Ogre::v1::MeshManager::~MeshManager | ( |  | ) |

## Member Function Documentation

## ◆ _initialise()

void Ogre::v1::MeshManager::_initialise | ( | void |  | ) |

Initialises the manager, only to be called by OGRE internally.

## ◆ _notifyResourceLoaded()

virtual void Ogre::ResourceManager::_notifyResourceLoaded | ( | Resource * | res | ) |
| virtualinherited

Notify this manager that a resource which it manages has been loaded.

## ◆ _notifyResourceTouched()

virtual void Ogre::ResourceManager::_notifyResourceTouched | ( | Resource * | res | ) |
| virtualinherited

Notify this manager that a resource which it manages has been 'touched', i.e.

used.

## ◆ _notifyResourceUnloaded()

virtual void Ogre::ResourceManager::_notifyResourceUnloaded | ( | Resource * | res | ) |
| virtualinherited

Notify this manager that a resource which it manages has been unloaded.

## ◆ create()

MeshPtr Ogre::v1::MeshManager::create | ( | const String & | name,
|  | const String & | group,
|  | bool | isManual = `false`,
|  | ManualResourceLoader * | loader = `0`,
|  | const NameValuePairList * | createParams = `0`
| ) |  |

Create a new mesh.

See also
  ResourceManager::createResource

## ◆ createBezierPatch()

PatchMeshPtr Ogre::v1::MeshManager::createBezierPatch | ( | const String & | name,
|  | const String & | groupName,
|  | void * | controlPointBuffer,
|  | VertexDeclaration * | declaration,
|  | size_t | width,
|  | size_t | height,
|  | size_t | uMaxSubdivisionLevel = `PatchSurface::AUTO_LEVEL`,
|  | size_t | vMaxSubdivisionLevel = `PatchSurface::AUTO_LEVEL`,
|  | PatchSurface::VisibleSide | visibleSide = `PatchSurface::VS_FRONT`,
|  | HardwareBuffer::Usage | vbUsage = `HardwareBuffer::HBU_STATIC_WRITE_ONLY`,
|  | HardwareBuffer::Usage | ibUsage = `HardwareBuffer::HBU_DYNAMIC_WRITE_ONLY`,
|  | bool | vbUseShadow = `true`,
|  | bool | ibUseShadow = `true`
| ) |  |

Creates a Bezier patch based on an array of control vertices.

Parameters

  name | The name to give the newly created mesh.
  groupName | The name of the resource group to assign the mesh to
  controlPointBuffer | A pointer to a buffer containing the vertex data which defines control points of the curves rather than actual vertices. Note that you are expected to provide not just position information, but potentially normals and texture coordinates too. The format of the buffer is defined in the VertexDeclaration parameter
  declaration | VertexDeclaration describing the contents of the buffer. Note this declaration must only draw on buffer source 0!
  width | Specifies the width of the patch in control points. Note this parameter must greater than or equal to 3.
  height | Specifies the height of the patch in control points. Note this parameter must greater than or equal to 3.
  uMaxSubdivisionLevel,vMaxSubdivisionLevel | If you want to manually set the top level of subdivision, do it here, otherwise let the system decide.
  visibleSide | Determines which side of the patch (or both) triangles are generated for.
  vbUsage | Vertex buffer usage flags. Recommend the default since vertex buffer should be static.
  ibUsage | Index buffer usage flags. Recommend the default since index buffer should be dynamic to change levels but not readable.
  vbUseShadow | Flag to determine if a shadow buffer is generated for the vertex buffer. See HardwareBuffer for full details.
  ibUseShadow | Flag to determine if a shadow buffer is generated for the index buffer. See HardwareBuffer for full details.

## ◆ createCurvedIllusionPlane()

MeshPtr Ogre::v1::MeshManager::createCurvedIllusionPlane | ( | const String & | name,
|  | const String & | groupName,
|  | const Plane & | plane,
|  | Real | width,
|  | Real | height,
|  | Real | curvature,
|  | int | xsegments = `1`,
|  | int | ysegments = `1`,
|  | bool | normals = `true`,
|  | unsigned short | numTexCoordSets = `1`,
|  | Real | uTile = `1.0f`,
|  | Real | vTile = `1.0f`,
|  | const Vector3 & | upVector = `Vector3::UNIT_Y`,
|  | const Quaternion & | orientation = `Quaternion::IDENTITY`,
|  | HardwareBuffer::Usage | vertexBufferUsage = `HardwareBuffer::HBU_STATIC_WRITE_ONLY`,
|  | HardwareBuffer::Usage | indexBufferUsage = `HardwareBuffer::HBU_STATIC_WRITE_ONLY`,
|  | bool | vertexShadowBuffer = `true`,
|  | bool | indexShadowBuffer = `true`,
|  | int | ySegmentsToKeep = `-1`
| ) |  |

Creates a plane, which because of it's texture coordinates looks like a curved surface, useful for skies in a skybox.

Parameters

  name | The name to give the resulting mesh
  groupName | The name of the resource group to assign the mesh to
  plane | The orientation of the plane and distance from the origin
  width | The width of the plane in world coordinates
  height | The height of the plane in world coordinates
  curvature | The curvature of the plane. Good values are between 2 and 65. Higher values are more curved leading to a smoother effect, lower values are less curved meaning more distortion at the horizons but a better distance effect.
  xsegments | The number of segments to the plane in the x direction
  ysegments | The number of segments to the plane in the y direction
  normals | If true, normals are created perpendicular to the plane
  numTexCoordSets | The number of 2D texture coordinate sets created - by default the corners are created to be the corner of the texture.
  uTile | The number of times the texture should be repeated in the u direction
  vTile | The number of times the texture should be repeated in the v direction
  upVector | The 'Up' direction of the plane.
  orientation | The orientation of the overall sphere that's used to create the illusion
  vertexBufferUsage | The usage flag with which the vertex buffer for this plane will be created
  indexBufferUsage | The usage flag with which the index buffer for this plane will be created
  vertexShadowBuffer | If this flag is set to true, the vertex buffer will be created with a system memory shadow buffer, allowing you to read it back more efficiently than if it is in hardware
  indexShadowBuffer | If this flag is set to true, the index buffer will be created with a system memory shadow buffer, allowing you to read it back more efficiently than if it is in hardware
  ySegmentsToKeep | The number of segments from the top of the dome downwards to keep. -1 keeps all of them. This can save fillrate if you cannot see much of the sky lower down.

## ◆ createCurvedPlane()

MeshPtr Ogre::v1::MeshManager::createCurvedPlane | ( | const String & | name,
|  | const String & | groupName,
|  | const Plane & | plane,
|  | Real | width,
|  | Real | height,
|  | Real | bow = `0.5f`,
|  | int | xsegments = `1`,
|  | int | ysegments = `1`,
|  | bool | normals = `false`,
|  | unsigned short | numTexCoordSets = `1`,
|  | Real | uTile = `1.0f`,
|  | Real | vTile = `1.0f`,
|  | const Vector3 & | upVector = `Vector3::UNIT_Y`,
|  | HardwareBuffer::Usage | vertexBufferUsage = `HardwareBuffer::HBU_STATIC_WRITE_ONLY`,
|  | HardwareBuffer::Usage | indexBufferUsage = `HardwareBuffer::HBU_STATIC_WRITE_ONLY`,
|  | bool | vertexShadowBuffer = `true`,
|  | bool | indexShadowBuffer = `true`
| ) |  |

Creates a genuinely curved plane, by default majoring on the x/y axes facing positive Z.

Parameters

  name | The name to give the resulting mesh
  groupName | The name of the resource group to assign the mesh to
  plane | The orientation of the plane and distance from the origin
  width | The width of the plane in world coordinates
  height | The height of the plane in world coordinates
  bow | The amount of 'bow' in the curved plane. (Could also be considered the depth.)
  xsegments | The number of segments to the plane in the x direction
  ysegments | The number of segments to the plane in the y direction
  normals | If true, normals are created perpendicular to the plane
  numTexCoordSets | The number of 2D texture coordinate sets created - by default the corners are created to be the corner of the texture.
  uTile | The number of times the texture should be repeated in the u direction
  vTile | The number of times the texture should be repeated in the v direction
  upVector | The 'Up' direction of the plane.
  vertexBufferUsage | The usage flag with which the vertex buffer for this plane will be created
  indexBufferUsage | The usage flag with which the index buffer for this plane will be created
  vertexShadowBuffer | If this flag is set to true, the vertex buffer will be created with a system memory shadow buffer, allowing you to read it back more efficiently than if it is in hardware
  indexShadowBuffer | If this flag is set to true, the index buffer will be created with a system memory shadow buffer, allowing you to read it back more efficiently than if it is in hardware

## ◆ createManual()

MeshPtr Ogre::v1::MeshManager::createManual | ( | const String & | name,
|  | const String & | groupName,
|  | ManualResourceLoader * | loader = `0`
| ) |  |

Creates a new Mesh specifically for manual definition rather than loading from an object file.

Remarks
  Note that once you've defined your mesh, you must call Mesh::_setBounds and Mesh::_setBoundingRadius in order to define the bounds of your mesh. In previous versions of OGRE you could call Mesh::_updateBounds, but OGRE's support of write-only vertex buffers makes this no longer appropriate.

Parameters

  name | The name to give the new mesh
  groupName | The name of the resource group to assign the mesh to
  loader | ManualResourceLoader which will be called to load this mesh when the time comes. It is recommended that you populate this field in order that the mesh can be rebuilt should the need arise

## ◆ createOrRetrieve() [1/2]

virtual ResourceCreateOrRetrieveResult Ogre::ResourceManager::createOrRetrieve | ( | const String & | name,
|  | const String & | group,
|  | bool | isManual = `false`,
|  | ManualResourceLoader * | loader = `0`,
|  | const NameValuePairList * | createParams = `0`
| ) |  |
| virtualinherited

Create a new resource, or retrieve an existing one with the same name if it already exists.

Remarks
  This method performs the same task as calling getByName() followed by create() if that returns null. The advantage is that it does it in one call so there are no race conditions if using multiple threads that could cause getByName() to return null, but create() to fail because another thread created a resource in between.

See also
  ResourceManager::createResource
  ResourceManager::getResourceByName

Returns
  A pair, the first element being the pointer, and the second being an indicator specifying whether the resource was newly created.

## ◆ createOrRetrieve() [2/2]

ResourceCreateOrRetrieveResult Ogre::v1::MeshManager::createOrRetrieve | ( | const String & | name,
|  | const String & | group,
|  | bool | isManual = `false`,
|  | ManualResourceLoader * | loader = `0`,
|  | const NameValuePairList * | params = `0`,
|  | HardwareBuffer::Usage | vertexBufferUsage = `HardwareBuffer::HBU_STATIC_WRITE_ONLY`,
|  | HardwareBuffer::Usage | indexBufferUsage = `HardwareBuffer::HBU_STATIC_WRITE_ONLY`,
|  | bool | vertexBufferShadowed = `true`,
|  | bool | indexBufferShadowed = `true`
| ) |  |

Create a new mesh, or retrieve an existing one with the same name if it already exists.

Parameters

  vertexBufferUsage | The usage flags with which the vertex buffer(s) will be created
  indexBufferUsage | The usage flags with which the index buffer(s) created for this mesh will be created with.
  vertexBufferShadowed | If true, the vertex buffers will be shadowed by system memory copies for faster read access
  indexBufferShadowed | If true, the index buffers will be shadowed by system memory copies for faster read access

See also
  ResourceManager::createOrRetrieve

## ◆ createPlane()

MeshPtr Ogre::v1::MeshManager::createPlane | ( | const String & | name,
|  | const String & | groupName,
|  | const Plane & | plane,
|  | Real | width,
|  | Real | height,
|  | int | xsegments = `1`,
|  | int | ysegments = `1`,
|  | bool | normals = `true`,
|  | unsigned short | numTexCoordSets = `1`,
|  | Real | uTile = `1.0f`,
|  | Real | vTile = `1.0f`,
|  | const Vector3 & | upVector = `Vector3::UNIT_Y`,
|  | HardwareBuffer::Usage | vertexBufferUsage = `HardwareBuffer::HBU_STATIC_WRITE_ONLY`,
|  | HardwareBuffer::Usage | indexBufferUsage = `HardwareBuffer::HBU_STATIC_WRITE_ONLY`,
|  | bool | vertexShadowBuffer = `true`,
|  | bool | indexShadowBuffer = `true`
| ) |  |

Creates a basic plane, by default majoring on the x/y axes facing positive Z.

Parameters

  name | The name to give the resulting mesh
  groupName | The name of the resource group to assign the mesh to
  plane | The orientation of the plane and distance from the origin
  width | The width of the plane in world coordinates
  height | The height of the plane in world coordinates
  xsegments | The number of segments to the plane in the x direction
  ysegments | The number of segments to the plane in the y direction
  normals | If true, normals are created perpendicular to the plane
  numTexCoordSets | The number of 2D texture coordinate sets created - by default the corners are created to be the corner of the texture.
  uTile | The number of times the texture should be repeated in the u direction
  vTile | The number of times the texture should be repeated in the v direction
  upVector | The 'Up' direction of the plane texture coordinates.
  vertexBufferUsage | The usage flag with which the vertex buffer for this plane will be created
  indexBufferUsage | The usage flag with which the index buffer for this plane will be created
  vertexShadowBuffer | If this flag is set to true, the vertex buffer will be created with a system memory shadow buffer, allowing you to read it back more efficiently than if it is in hardware
  indexShadowBuffer | If this flag is set to true, the index buffer will be created with a system memory shadow buffer, allowing you to read it back more efficiently than if it is in hardware

## ◆ createResource()

virtual ResourcePtr Ogre::ResourceManager::createResource | ( | const String & | name,
|  | const String & | group,
|  | bool | isManual = `false`,
|  | ManualResourceLoader * | loader = `0`,
|  | const NameValuePairList * | createParams = `0`
| ) |  |
| virtualinherited

Creates a new blank resource, but does not immediately load it.

Remarks
  Resource managers handle disparate types of resources, so if you want to get at the detailed interface of this resource, you'll have to cast the result to the subclass you know you're creating.

Parameters

  name | The unique name of the resource
  group | The name of the resource group to attach this new resource to
  isManual | Is this resource manually loaded? If so, you should really populate the loader parameter in order that the load process can call the loader back when loading is required.
  loader | Pointer to a ManualLoader implementation which will be called when the Resource wishes to load (should be supplied if you set isManual to true). You can in fact leave this parameter null if you wish, but the Resource will never be able to reload if anything ever causes it to unload. Therefore provision of a proper ManualLoader instance is strongly recommended.
  createParams | If any parameters are required to create an instance, they should be supplied here as name / value pairs

## ◆ destroyAllResourcePools()

void Ogre::ResourceManager::destroyAllResourcePools | ( |  | ) |
| inherited

destroy all pools

## ◆ destroyResourcePool() [1/2]

void Ogre::ResourceManager::destroyResourcePool | ( | const String & | name | ) |
| inherited

Destroy a resource pool.

## ◆ destroyResourcePool() [2/2]

void Ogre::ResourceManager::destroyResourcePool | ( | ResourcePool * | pool | ) |
| inherited

Destroy a resource pool.

## ◆ getBoundsPaddingFactor()

Real Ogre::v1::MeshManager::getBoundsPaddingFactor | ( | void |  | ) |

Gets the factor by which the bounding box of an entity is padded.

Default is 0.01

## ◆ getByHandle()

virtual ResourcePtr Ogre::ResourceManager::getByHandle | ( | ResourceHandle | handle | ) |
| virtualinherited

Retrieves a pointer to a resource by handle, or null if the resource does not exist.

## ◆ getByName()

MeshPtr Ogre::v1::MeshManager::getByName | ( | const String & | name,
|  | const String & | groupName = `ResourceGroupManager::AUTODETECT_RESOURCE_GROUP_NAME`
| ) |  |

Get a resource by name.

See also
  ResourceManager::getResourceByName

## ◆ getListener()

MeshSerializerListener* Ogre::v1::MeshManager::getListener | ( |  | ) |

Gets the listener used to control mesh loading through the serializer.

## ◆ getLoadingOrder()

virtual Real Ogre::ResourceManager::getLoadingOrder | ( | void |  | ) | const
| inlinevirtualinherited

Gets the relative loading order of resources of this type.

Remarks
  There are dependencies between some kinds of resource in terms of loading order, and this value enumerates that. Higher values load later during bulk loading tasks.

Implements Ogre::ScriptLoader.

## ◆ getMemoryBudget()

virtual size_t Ogre::ResourceManager::getMemoryBudget | ( | void |  | ) | const
| virtualinherited

Get the limit on the amount of memory this resource handler may use.

## ◆ getMemoryUsage()

virtual size_t Ogre::ResourceManager::getMemoryUsage | ( | void |  | ) | const
| inlinevirtualinherited

Gets the current memory usage, in bytes.

## ◆ getPrepareAllMeshesForShadowVolumes()

bool Ogre::v1::MeshManager::getPrepareAllMeshesForShadowVolumes | ( | void |  | ) |

Retrieves whether all Meshes should prepare themselves for shadow volumes.

## ◆ getResourceByName()

virtual ResourcePtr Ogre::ResourceManager::getResourceByName | ( | const String & | name,
|  | const String & | groupName = `ResourceGroupManager::AUTODETECT_RESOURCE_GROUP_NAME`
| ) |  |
| virtualinherited

Retrieves a pointer to a resource by name, or null if the resource does not exist.

## ◆ getResourceIterator()

ResourceMapIterator Ogre::ResourceManager::getResourceIterator | ( | void |  | ) |
| inlineinherited

Returns an iterator over all resources in this manager.

Note
  Use of this iterator is NOT thread safe!

## ◆ getResourcePool()

ResourcePool* Ogre::ResourceManager::getResourcePool | ( | const String & | name | ) |
| inherited

Create a resource pool, or reuse one that already exists.

## ◆ getResourceType()

const String& Ogre::ResourceManager::getResourceType | ( | void |  | ) | const
| inlineinherited

Gets a string identifying the type of resource this manager handles.

## ◆ getScriptPatterns()

virtual const StringVector& Ogre::ResourceManager::getScriptPatterns | ( | void |  | ) | const
| inlinevirtualinherited

Gets the file patterns which should be used to find scripts for this ResourceManager.

Remarks
  Some resource managers can read script files in order to define resources ahead of time. These resources are added to the available list inside the manager, but none are loaded initially. This allows you to load the items that are used on demand, or to load them all as a group if you wish (through ResourceGroupManager).

  This method lets you determine the file pattern which will be used to identify scripts intended for this manager.

Returns
  A list of file patterns, in the order they should be searched in.

See also
  isScriptingSupported, parseScript

Implements Ogre::ScriptLoader.

## ◆ getSingleton()

static MeshManager& Ogre::v1::MeshManager::getSingleton | ( | void |  | ) |
| static

Override standard Singleton retrieval.

Remarks
  Why do we do this? Well, it's because the Singleton implementation is in a .h file, which means it gets compiled into anybody who includes it. This is needed for the Singleton template to work, but we actually only want it compiled into the implementation of the class based on the Singleton, not all of them. If we don't change this, we get link errors when trying to use the Singleton-based class from an outside dll.

  This method just delegates to the template version anyway, but the implementation stays in this single compilation unit, preventing link errors.

## ◆ getSingletonPtr()

static MeshManager* Ogre::v1::MeshManager::getSingletonPtr | ( | void |  | ) |
| static

Override standard Singleton retrieval.

Remarks
  Why do we do this? Well, it's because the Singleton implementation is in a .h file, which means it gets compiled into anybody who includes it. This is needed for the Singleton template to work, but we actually only want it compiled into the implementation of the class based on the Singleton, not all of them. If we don't change this, we get link errors when trying to use the Singleton-based class from an outside dll.

  This method just delegates to the template version anyway, but the implementation stays in this single compilation unit, preventing link errors.

## ◆ getVerbose()

virtual bool Ogre::ResourceManager::getVerbose | ( | void |  | ) |
| inlinevirtualinherited

Gets whether this manager and its resources habitually produce log output.

## ◆ load() [1/2]

MeshPtr Ogre::v1::MeshManager::load | ( | const String & | filename,
|  | const String & | groupName,
|  | HardwareBuffer::Usage | vertexBufferUsage = `HardwareBuffer::HBU_STATIC_WRITE_ONLY`,
|  | HardwareBuffer::Usage | indexBufferUsage = `HardwareBuffer::HBU_STATIC_WRITE_ONLY`,
|  | bool | vertexBufferShadowed = `true`,
|  | bool | indexBufferShadowed = `true`
| ) |  |

Loads a mesh from a file, making it immediately available for use.

Note
  If the model has already been created (prepared or loaded), the existing instance will be returned.

Remarks
  Ogre loads model files from it's own proprietary format called .mesh. This is because having a single file format is better for runtime performance, and we also have control over pre-processed data (such as collision boxes, LOD reductions etc).

Parameters

  filename | The name of the .mesh file
  groupName | The name of the resource group to assign the mesh to
  vertexBufferUsage | The usage flags with which the vertex buffer(s) will be created
  indexBufferUsage | The usage flags with which the index buffer(s) created for this mesh will be created with.
  vertexBufferShadowed | If true, the vertex buffers will be shadowed by system memory copies for faster read access
  indexBufferShadowed | If true, the index buffers will be shadowed by system memory copies for faster read access

## ◆ load() [2/2]

virtual ResourcePtr Ogre::ResourceManager::load | ( | const String & | name,
|  | const String & | group,
|  | bool | isManual = `false`,
|  | ManualResourceLoader * | loader = `0`,
|  | const NameValuePairList * | loadParams = `0`,
|  | bool | backgroundThread = `false`
| ) |  |
| virtualinherited

Generic load method, used to create a Resource specific to this ResourceManager without using one of the specialised 'load' methods (containing per-Resource-type parameters).

Parameters

  name | The name of the Resource
  group | The resource group to which this resource will belong
  isManual | Is the resource to be manually loaded? If so, you should provide a value for the loader parameter
  loader | The manual loader which is to perform the required actions when this resource is loaded; only applicable when you specify true for the previous parameter
  loadParams | Optional pointer to a list of name/value pairs containing loading parameters for this type of resource.
  backgroundThread | Optional boolean which lets the load routine know if it is being run on the background resource loading thread

## ◆ loadResource()

void Ogre::v1::MeshManager::loadResource | ( | Resource * | res | ) |
| virtual

See also
  ManualResourceLoader::loadResource

Implements Ogre::ManualResourceLoader.

## ◆ operator delete() [1/3]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr | ) |
| inlineinherited

## ◆ operator delete() [2/3]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |
| ) |  |
| inlineinherited

## ◆ operator delete() [3/3]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | void * |
| ) |  |
| inlineinherited

## ◆ operator delete[]() [1/2]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr | ) |
| inlineinherited

## ◆ operator delete[]() [2/2]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |
| ) |  |
| inlineinherited

## ◆ operator new() [1/3]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz | ) |
| inlineinherited

## ◆ operator new() [2/3]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func
| ) |  |
| inlineinherited

operator new, with debug line info

## ◆ operator new() [3/3]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | void * | ptr
| ) |  |
| inlineinherited

placement operator new

## ◆ operator new[]() [1/2]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz | ) |
| inlineinherited

## ◆ operator new[]() [2/2]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func
| ) |  |
| inlineinherited

array operator new, with debug line info

## ◆ parseScript()

virtual void Ogre::ResourceManager::parseScript | ( | DataStreamPtr & | stream,
|  | const String & | groupName
| ) |  |
| inlinevirtualinherited

Parse the definition of a set of resources from a script file.

Remarks
  Some resource managers can read script files in order to define resources ahead of time. These resources are added to the available list inside the manager, but none are loaded initially. This allows you to load the items that are used on demand, or to load them all as a group if you wish (through ResourceGroupManager).

Parameters

  stream | Weak reference to a data stream which is the source of the script
  groupName | The name of the resource group that resources which are parsed are to become a member of. If this group is loaded or unloaded, then the resources discovered in this script will be loaded / unloaded with it.

Implements Ogre::ScriptLoader.

Reimplemented in Ogre::MaterialManager, and Ogre::FontManager.

## ◆ prepare() [1/2]

MeshPtr Ogre::v1::MeshManager::prepare | ( | const String & | filename,
|  | const String & | groupName,
|  | HardwareBuffer::Usage | vertexBufferUsage = `HardwareBuffer::HBU_STATIC_WRITE_ONLY`,
|  | HardwareBuffer::Usage | indexBufferUsage = `HardwareBuffer::HBU_STATIC_WRITE_ONLY`,
|  | bool | vertexBufferShadowed = `true`,
|  | bool | indexBufferShadowed = `true`
| ) |  |

Prepares a mesh for loading from a file.

This does the IO in advance of the call to load().

Note
  If the model has already been created (prepared or loaded), the existing instance will be returned.

Remarks
  Ogre loads model files from it's own proprietary format called .mesh. This is because having a single file format is better for runtime performance, and we also have control over pre-processed data (such as collision boxes, LOD reductions etc).

Parameters

  filename | The name of the .mesh file
  groupName | The name of the resource group to assign the mesh to
  vertexBufferUsage | The usage flags with which the vertex buffer(s) will be created
  indexBufferUsage | The usage flags with which the index buffer(s) created for this mesh will be created with.
  vertexBufferShadowed | If true, the vertex buffers will be shadowed by system memory copies for faster read access
  indexBufferShadowed | If true, the index buffers will be shadowed by system memory copies for faster read access

## ◆ prepare() [2/2]

virtual ResourcePtr Ogre::ResourceManager::prepare | ( | const String & | name,
|  | const String & | group,
|  | bool | isManual = `false`,
|  | ManualResourceLoader * | loader = `0`,
|  | const NameValuePairList * | loadParams = `0`,
|  | bool | backgroundThread = `false`
| ) |  |
| virtualinherited

Generic prepare method, used to create a Resource specific to this ResourceManager without using one of the specialised 'prepare' methods (containing per-Resource-type parameters).

Parameters

  name | The name of the Resource
  group | The resource group to which this resource will belong
  isManual | Is the resource to be manually loaded? If so, you should provide a value for the loader parameter
  loader | The manual loader which is to perform the required actions when this resource is loaded; only applicable when you specify true for the previous parameter
  loadParams | Optional pointer to a list of name/value pairs containing loading parameters for this type of resource.
  backgroundThread | Optional boolean which lets the load routine know if it is being run on the background resource loading thread

## ◆ prepareResource()

virtual void Ogre::ManualResourceLoader::prepareResource | ( | Resource * | resource | ) |
| inlinevirtualinherited

Called when a resource wishes to load.

Note that this could get called in a background thread even in just a semithreaded ogre (OGRE_THREAD_SUPPORT==2). Thus, you must not access the rendersystem from this callback. Do that stuff in loadResource.

Parameters

  resource | The resource which wishes to load

## ◆ reloadAll() [1/2]

void Ogre::ResourceManager::reloadAll | ( | bool | reloadableOnly = `true` | ) |
| inlineinherited

Caused all currently loaded resources to be reloaded.

Remarks
  All resources currently being held in this manager which are also marked as currently loaded will be unloaded, then loaded again.

Parameters

  reloadableOnly | If true (the default), only reload the resource that is reloadable. Because some resources isn't reloadable, they will be unloaded but can't loaded again. Thus, you might not want to them unloaded. Or, you might unload all of them, and then populate them manually later.

See also
  Resource::isReloadable for resource is reloadable.

References Ogre::Resource::LF_DEFAULT, and Ogre::Resource::LF_INCLUDE_NON_RELOADABLE.

## ◆ reloadAll() [2/2]

virtual void Ogre::ResourceManager::reloadAll | ( | Resource::LoadingFlags | flags | ) |
| virtualinherited

Caused all currently loaded resources to be reloaded.

Remarks
  All resources currently being held in this manager which are also marked as currently loaded will be unloaded, then loaded again.

Parameters

  flags | Allow to restrict processing to only reloadable and/or unreferenced resources. Additionally, reloading could be done with preserving some selected resource states that could be used elsewhere.

See also
  Resource::LoadingFlags for additional information.

## ◆ reloadUnreferencedResources()

void Ogre::ResourceManager::reloadUnreferencedResources | ( | bool | reloadableOnly = `true` | ) |
| inlineinherited

Caused all currently loaded but not referenced by any other object resources to be reloaded.

Remarks
  This method behaves like reloadAll, except that it only reloads resources which are not in use, i.e. not referenced by other objects.

  Some referenced resource may exists 'weak' pointer to their sub-components (e.g. Entity held pointer to SubMesh), in this case, unload or reload that resource will cause dangerous pointer access. Use this function instead of reloadAll allows you avoid fail in those situations.

Parameters

  reloadableOnly | If true (the default), only reloads resources which can be subsequently automatically reloaded.

References Ogre::Resource::LF_ONLY_UNREFERENCED, and Ogre::Resource::LF_ONLY_UNREFERENCED_INCLUDE_NON_RELOADABLE.

## ◆ remove() [1/3]

virtual void Ogre::ResourceManager::remove | ( | const ResourcePtr & | r | ) |
| virtualinherited

Remove a single resource.

Remarks
  Removes a single resource, meaning it will be removed from the list of valid resources in this manager, also causing it to be unloaded.

Note
  The word 'Destroy' is not used here, since if any other pointers are referring to this resource, it will persist until they have finished with it; however to all intents and purposes it no longer exists and will likely get destroyed imminently.
  If you do have shared pointers to resources hanging around after the ResourceManager is destroyed, you may get problems on destruction of these resources if they were relying on the manager (especially if it is a plugin). If you find you get problems on shutdown in the destruction of resources, try making sure you release all your shared pointers before you shutdown OGRE.

## ◆ remove() [2/3]

virtual void Ogre::ResourceManager::remove | ( | const String & | name | ) |
| virtualinherited

Remove a single resource by name.

Remarks
  Removes a single resource, meaning it will be removed from the list of valid resources in this manager, also causing it to be unloaded.

Note
  The word 'Destroy' is not used here, since if any other pointers are referring to this resource, it will persist until they have finished with it; however to all intents and purposes it no longer exists and will likely get destroyed imminently.
  If you do have shared pointers to resources hanging around after the ResourceManager is destroyed, you may get problems on destruction of these resources if they were relying on the manager (especially if it is a plugin). If you find you get problems on shutdown in the destruction of resources, try making sure you release all your shared pointers before you shutdown OGRE.

## ◆ remove() [3/3]

virtual void Ogre::ResourceManager::remove | ( | ResourceHandle | handle | ) |
| virtualinherited

Remove a single resource by handle.

Remarks
  Removes a single resource, meaning it will be removed from the list of valid resources in this manager, also causing it to be unloaded.

Note
  The word 'Destroy' is not used here, since if any other pointers are referring to this resource, it will persist until they have finished with it; however to all intents and purposes it no longer exists and will likely get destroyed imminently.
  If you do have shared pointers to resources hanging around after the ResourceManager is destroyed, you may get problems on destruction of these resources if they were relying on the manager (especially if it is a plugin). If you find you get problems on shutdown in the destruction of resources, try making sure you release all your shared pointers before you shutdown OGRE.

## ◆ removeAll()

virtual void Ogre::ResourceManager::removeAll | ( | void |  | ) |
| virtualinherited

Removes all resources.

Note
  The word 'Destroy' is not used here, since if any other pointers are referring to these resources, they will persist until they have been finished with; however to all intents and purposes the resources no longer exist and will get destroyed imminently.
  If you do have shared pointers to resources hanging around after the ResourceManager is destroyed, you may get problems on destruction of these resources if they were relying on the manager (especially if it is a plugin). If you find you get problems on shutdown in the destruction of resources, try making sure you release all your shared pointers before you shutdown OGRE.

## ◆ removeUnreferencedResources()

virtual void Ogre::ResourceManager::removeUnreferencedResources | ( | bool | reloadableOnly = `true` | ) |
| virtualinherited

Remove all resources which are not referenced by any other object.

Remarks
  This method behaves like removeAll, except that it only removes resources which are not in use, ie not referenced by other objects. This allows you to free up some memory selectively whilst still keeping the group around (and the resources present, just not using much memory).

  Some referenced resource may exists 'weak' pointer to their sub-components (e.g. Entity held pointer to SubMesh), in this case, remove or reload that resource will cause dangerous pointer access. Use this function instead of removeAll allows you avoid fail in those situations.

Parameters

  reloadableOnly | If true (the default), only removes resources which can be subsequently automatically reloaded.

## ◆ resourceExists() [1/2]

virtual bool Ogre::ResourceManager::resourceExists | ( | const String & | name | ) |
| inlinevirtualinherited

Returns whether the named resource exists in this manager.

## ◆ resourceExists() [2/2]

virtual bool Ogre::ResourceManager::resourceExists | ( | ResourceHandle | handle | ) |
| inlinevirtualinherited

Returns whether a resource with the given handle exists in this manager.

## ◆ setBoundsPaddingFactor()

void Ogre::v1::MeshManager::setBoundsPaddingFactor | ( | Real | paddingFactor | ) |

Sets the factor by which the bounding box of an entity is padded.

## ◆ setListener()

void Ogre::v1::MeshManager::setListener | ( | MeshSerializerListener * | listener | ) |

Sets the listener used to control mesh loading through the serializer.

## ◆ setMemoryBudget()

virtual void Ogre::ResourceManager::setMemoryBudget | ( | size_t | bytes | ) |
| virtualinherited

Set a limit on the amount of memory this resource handler may use.

Remarks
  If, when asked to load a new resource, the manager believes it will exceed this memory budget, it will temporarily unload a resource to make room for the new one. This unloading is not permanent and the Resource is not destroyed; it simply needs to be reloaded when next used.

## ◆ setPrepareAllMeshesForShadowVolumes()

void Ogre::v1::MeshManager::setPrepareAllMeshesForShadowVolumes | ( | bool | enable | ) |

Tells the mesh manager that all future meshes should prepare themselves for shadow volumes on loading.

## ◆ setVerbose()

virtual void Ogre::ResourceManager::setVerbose | ( | bool | v | ) |
| inlinevirtualinherited

Sets whether this manager and its resources habitually produce log output.

## ◆ unload() [1/2]

virtual void Ogre::ResourceManager::unload | ( | const String & | name | ) |
| virtualinherited

Unloads a single resource by name.

Remarks
  Unloaded resources are not removed, they simply free up their memory as much as they can and wait to be reloaded.

See also
  ResourceGroupManager for unloading of resource groups.

## ◆ unload() [2/2]

virtual void Ogre::ResourceManager::unload | ( | ResourceHandle | handle | ) |
| virtualinherited

Unloads a single resource by handle.

Remarks
  Unloaded resources are not removed, they simply free up their memory as much as they can and wait to be reloaded.

See also
  ResourceGroupManager for unloading of resource groups.

## ◆ unloadAll() [1/2]

void Ogre::ResourceManager::unloadAll | ( | bool | reloadableOnly = `true` | ) |
| inlineinherited

Unloads all resources.

Remarks
  Unloaded resources are not removed, they simply free up their memory as much as they can and wait to be reloaded.

See also
  ResourceGroupManager for unloading of resource groups.

Parameters

  reloadableOnly | If true (the default), only unload the resource that is reloadable. Because some resources isn't reloadable, they will be unloaded but can't load them later. Thus, you might not want to them unloaded. Or, you might unload all of them, and then populate them manually later.

See also
  Resource::isReloadable for resource is reloadable.

References Ogre::Resource::LF_DEFAULT, and Ogre::Resource::LF_INCLUDE_NON_RELOADABLE.

## ◆ unloadAll() [2/2]

virtual void Ogre::ResourceManager::unloadAll | ( | Resource::LoadingFlags | flags | ) |
| virtualinherited

Unloads all resources.

Remarks
  Unloaded resources are not removed, they simply free up their memory as much as they can and wait to be reloaded.

See also
  ResourceGroupManager for unloading of resource groups.

Parameters

  flags | Allow to restrict processing to only reloadable and/or unreferenced resources.

See also
  Resource::LoadingFlags for additional information.

## ◆ unloadUnreferencedResources()

void Ogre::ResourceManager::unloadUnreferencedResources | ( | bool | reloadableOnly = `true` | ) |
| inlineinherited

Unload all resources which are not referenced by any other object.

Remarks
  This method behaves like unloadAll, except that it only unloads resources which are not in use, ie not referenced by other objects. This allows you to free up some memory selectively whilst still keeping the group around (and the resources present, just not using much memory).

  Some referenced resource may exists 'weak' pointer to their sub-components (e.g. Entity held pointer to SubMesh), in this case, unload or reload that resource will cause dangerous pointer access. Use this function instead of unloadAll allows you avoid fail in those situations.

Parameters

  reloadableOnly | If true (the default), only unloads resources which can be subsequently automatically reloaded.

References Ogre::Resource::LF_ONLY_UNREFERENCED, and Ogre::Resource::LF_ONLY_UNREFERENCED_INCLUDE_NON_RELOADABLE.

## ◆ unshareVertices()

static void Ogre::v1::MeshManager::unshareVertices | ( | Mesh * | mesh | ) |
| static

Called when we you use a mesh which has shared vertices, the function creates separate vertex/index buffers and also recreates the bone assignments.

## Member Data Documentation

## ◆ OGRE_AUTO_MUTEX

Ogre::ResourceManager::OGRE_AUTO_MUTEX
| inherited

The documentation for this class was generated from the following file:

- OgreMeshManager.h